<?php
/*
API Audio Bкoнтaктe
Aвтop: Neo
*/
@ini_set('arg_separator.output',"&");
//==================================================//
function GetAPI($url,$param=""){
global $set;
$user_agent="VK MUSIC PHP/1.0";
$referer="http://vk.com";

$ch=curl_init();
curl_setopt($ch, CURLOPT_URL, $url);
curl_setopt($ch, CURLOPT_HEADER,0);
curl_setopt($ch, CURLOPT_USERAGENT, $user_agent);
curl_setopt($ch, CURLOPT_RETURNTRANSFER,1);
curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 30);
curl_setopt($ch, CURLOPT_TIMEOUT, 30);
curl_setopt($ch, CURLOPT_POST, 1);
curl_setopt($ch, CURLOPT_POSTFIELDS, $param);
if($referer){
curl_setopt($ch, CURLOPT_REFERER, $referer);
};
//curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);

$content=curl_exec($ch);
if($content===false){
$error=curl_error($ch);
$content.="Error:".$error;
};
curl_close($ch);

$resp=json_decode($content,true);

return $resp;
};
//==================================================//
function AuthUrl($client_id,$redirect,$scope=""){
global $set;
if((!isset($scope))||($scope==="")){
$scope="audio,offline";
};
$scope=trim(strtolower($scope));
$url="https://oauth.vk.com/authorize?client_id=".$client_id."&display=mobile&redirect_uri=".urlencode($redirect)."&scope=".urlencode($scope)."&response_type=code&v=".$set["vk_ver"];
return $url;
};
//==================================================//
function receiveOAuthToken($code,$redirect,$secret=""){
global $set;
$data=array();
$url="https://oauth.vk.com/access_token";
$param["client_id"]=$set["vk_api"];
$param["client_secret"]=$secret;
$param["redirect_uri"]=$redirect;
$param["code"]=$code;

$params=http_build_query($param);
$resp=GetAPI($url,$params);

if(isset($resp["access_token"]))$data["token"]=$resp["access_token"];
if(isset($resp["expires_in"]))$data["token_sec"]=$resp["expires_in"];
if(isset($resp["secret"]))$data["secret"]=$resp["secret"];
if(isset($resp["error"]))$data["error"]=$resp["error"];
if(isset($resp["user_id"]))$data["user"]=$resp["user_id"];

return $data;
};
//==================================================//
function AudioSearch($id,$search,$performer_only="",$sort="",$offset=0,$count=300,$auto_complete=1,$lyrics=0){
global $set;
$method="audio.search";
$param=array();

$param["q"]=trim($search);
$param["auto_complete"]=$auto_complete;
$param["lyrics"]=$lyrics;
$param["performer_only"]=$performer_only;
$param["sort"]=$sort;
$param["offset"]=$offset;
$param["count"]=$count;

$url="https://api.vk.com/method/".$method.".json";
$param["api_id"]=$set["vk_api"];
$param["v"]=$set["vk_ver"];
$param["access_token"]=$set["vk_token"];
$param["test_mode"]=1;

ksort($param);
$sig=$set["vk_id"];
foreach($param as $key=>$val){
$sig.=$key."=".$val;
};
//$sig.=$set["vk_secret"];
$param["sig"]=md5($sig);

$params=http_build_query($param);
$resp=GetAPI($url,$params);
$audio=$resp["response"]["items"];

mysql_query("DELETE FROM `vk_music` WHERE `id_search`='".$id."' AND `time`<'".(time()-24*60*60)."'");

$n=0;
if(is_array($audio)){
$sql="INSERT INTO `vk_music` (`id_search`,`audio_id`,`owner_id`,`artist`,`title`,`duration`,`sort`,`author`,`time`) VALUES ";
foreach($audio as $key=>$val){
if(empty($val["id"]))continue;
$sql.="('".$id."','".my_esc($val["id"])."','".my_esc($val["owner_id"])."','".my_esc(html_entity_decode($val["artist"]))."','".my_esc(html_entity_decode($val["title"]))."','".my_esc($val["duration"])."','".my_esc($sort)."','".my_esc($performer_only)."','".time()."'),";
$n++;
};
$sql=rtrim($sql,",");
mysql_query($sql);
};

return $n;
};
//==================================================//
function AudioInfo($audio){
global $set;
$method="audio.getById";
$param=array();
$param["audios"]=$audio;

$url="https://api.vk.com/method/".$method.".json";
$param["api_id"]=$set["vk_api"];
$param["v"]=$set["vk_ver"];
$param["access_token"]=$set["vk_token"];
$param["test_mode"]=1;

ksort($param);
$sig=$set["vk_id"];
foreach($param as $key=>$val){
$sig.=$key."=".$val;
};
//$sig.=$set["vk_secret"];
$param["sig"]=md5($sig);

$params=http_build_query($param);
$resp=GetAPI($url,$params);
$content=$resp["response"][0];

return $content;
};
//==================================================//
function AudioDown($file,$name){
$len=get_headers($file,1);
if($len[0]=="HTTP/1.1 200 OK"){
if(ob_get_level()){
ob_end_clean();
};

if(isset($len["Content-Type"])){
$content_type=$len["Content-Type"];
}else{
$content_type="application/octet-stream";
};

header("Content-Description: File Transfer");
header("Content-Length: ".$len["Content-Length"]);
header("Content-Type: ".$content_type);
header("Content-Disposition: attachment; filename=".$name.".mp3");
header("Content-Transfer-Encoding: binary");
header("Expires: ".gmdate("D, d M Y H:i:s", time()+3600)." GMT");
header("Accept-Ranges: bytes");
header("Connection: close");
header("Cache-Control: must-revalidate");
header("Pragma: public");

$ch=curl_init();
curl_setopt($ch, CURLOPT_URL, $file);
curl_setopt($ch, CURLOPT_HEADER, 0);
curl_exec($ch);
curl_close($ch);

//exit;
};
};
//==================================================//
function translit_rus($str){
include_once("latinic.php");

$str=strtr($str,$charmap);
$str=substr($str,0,128);
$str=preg_replace('/[^a-z0-9\-\d_]+/i','_',$str);
return $str;
};
//==================================================//
function vk_time($time=0){
$min=floor($time/60);
$sec=floor($time%60);
$times=($min>0?$min." мин. ":"").$sec." ceк.";
return $times;
};
//==================================================//
function vk_size($url){
$len=get_headers($url,1);
$size=$len["Content-Length"];
$code=$size." бaйт";
if($size>=1024){
$size=round($size/1024,2);
$code=$size." Kб";
};
if($size>=1024){
$size=round($size/1024,2);
$code=$size." Mб";
};
return $code;
};
//==================================================//
?>